// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIDatePicker;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a date picker.
  The component needs a DateFormat Pattern from a converter. The converter
  should be an instance of DateTimeConverter and return a valid pattern from
  the method getPattern()
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.DatePickerTagDeclaration}.
 */
public class UIDatePicker
    extends AbstractUIDatePicker implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.DatePicker";

  private org.apache.myfaces.tobago.context.Markup markup;
  private org.apache.myfaces.tobago.layout.Measure marginLeft;
  private java.lang.String forComponent;
  private java.lang.String link;
  private java.lang.Integer tabIndex;
  private org.apache.myfaces.tobago.layout.Measure minimumHeight;
  private java.lang.String tip;
  private org.apache.myfaces.tobago.layout.Measure height;
  private org.apache.myfaces.tobago.layout.Measure minimumWidth;
  private java.lang.Integer rowSpan;
  private org.apache.myfaces.tobago.layout.Measure left;
  private java.lang.Integer columnSpan;
  private org.apache.myfaces.tobago.layout.Measure maximumHeight;
  private org.apache.myfaces.tobago.layout.Measure top;
  private org.apache.myfaces.tobago.layout.Measure currentWidth;
  private org.apache.myfaces.tobago.layout.Measure marginTop;
  private org.apache.myfaces.tobago.layout.Measure marginRight;
  private org.apache.myfaces.tobago.layout.Measure width;
  private java.lang.String resource;
  private java.lang.Boolean jsfResource;
  private org.apache.myfaces.tobago.layout.Measure currentHeight;
  private org.apache.myfaces.tobago.layout.Measure preferredHeight;
  private java.lang.String image;
  private org.apache.myfaces.tobago.layout.Display display;
  private org.apache.myfaces.tobago.layout.Measure maximumWidth;
  private org.apache.myfaces.tobago.layout.Measure preferredWidth;
  private org.apache.myfaces.tobago.layout.Measure marginBottom;
  private java.lang.Integer verticalIndex;
  private java.lang.String[] renderedPartially;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.String onclick;
  private java.lang.Integer horizontalIndex;
  private java.lang.Boolean disabled;


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    if (marginLeft != null) {
      return marginLeft;
    }
    ValueExpression ve = getValueExpression("marginLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this);
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    this.marginLeft = marginLeft;
  }

  /**
  Id of the component, this is related to.

  */
  public java.lang.String getFor() {
    if (forComponent != null) {
      return forComponent;
    }
    ValueExpression ve = getValueExpression("for");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setFor(java.lang.String forComponent) {
    this.forComponent = forComponent;
  }

  public java.lang.String getLink() {
    if (link != null) {
      return link;
    }
    ValueExpression ve = getValueExpression("link");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLink(java.lang.String link) {
    this.link = link;
  }

  /**
  Controls the navigation of the focus through the
   input controls on a page with the Tab-Key.
   The navigation starts from the element with
   the lowest tabIndex value to the element with the highest value.
   Elements that have identical tabIndex values should be navigated
   in the order they appear in the character stream
   Elements that are disabled or with a negative tabIndex
   do not participate in the tabbing order.

  */
  public java.lang.Integer getTabIndex() {
    if (tabIndex != null) {
      return tabIndex;
    }
    ValueExpression ve = getValueExpression("tabIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTabIndex(java.lang.Integer tabIndex) {
    this.tabIndex = tabIndex;
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    if (minimumHeight != null) {
      return minimumHeight;
    }
    ValueExpression ve = getValueExpression("minimumHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this);
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    this.minimumHeight = minimumHeight;
  }

  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    if (height != null) {
      return height;
    }
    ValueExpression ve = getValueExpression("height");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this);
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    this.height = height;
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    if (minimumWidth != null) {
      return minimumWidth;
    }
    ValueExpression ve = getValueExpression("minimumWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer)getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this);
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    this.minimumWidth = minimumWidth;
  }

  public java.lang.Integer getRowSpan() {
    if (rowSpan != null) {
      return rowSpan;
    }
    ValueExpression ve = getValueExpression("rowSpan");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    this.rowSpan = rowSpan;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    if (left != null) {
      return left;
    }
    ValueExpression ve = getValueExpression("left");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    this.left = left;
  }

  public java.lang.Integer getColumnSpan() {
    if (columnSpan != null) {
      return columnSpan;
    }
    ValueExpression ve = getValueExpression("columnSpan");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    this.columnSpan = columnSpan;
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    if (maximumHeight != null) {
      return maximumHeight;
    }
    ValueExpression ve = getValueExpression("maximumHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this);
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    this.maximumHeight = maximumHeight;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    if (top != null) {
      return top;
    }
    ValueExpression ve = getValueExpression("top");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    this.top = top;
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    if (currentWidth != null) {
      return currentWidth;
    }
    ValueExpression ve = getValueExpression("currentWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    this.currentWidth = currentWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    if (marginTop != null) {
      return marginTop;
    }
    ValueExpression ve = getValueExpression("marginTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this);
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    this.marginTop = marginTop;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    if (marginRight != null) {
      return marginRight;
    }
    ValueExpression ve = getValueExpression("marginRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this);
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    this.marginRight = marginRight;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    if (width != null) {
      return width;
    }
    ValueExpression ve = getValueExpression("width");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this);
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    this.width = width;
  }

  public java.lang.String getResource() {
    if (resource != null) {
      return resource;
    }
    ValueExpression ve = getValueExpression("resource");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setResource(java.lang.String resource) {
    this.resource = resource;
  }

  public boolean isJsfResource() {
    if (jsfResource != null) {
      return jsfResource;
    }
    ValueExpression ve = getValueExpression("jsfResource");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setJsfResource(boolean jsfResource) {
    this.jsfResource = jsfResource;
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    if (currentHeight != null) {
      return currentHeight;
    }
    ValueExpression ve = getValueExpression("currentHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    this.currentHeight = currentHeight;
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    if (preferredHeight != null) {
      return preferredHeight;
    }
    ValueExpression ve = getValueExpression("preferredHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this);
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    this.preferredHeight = preferredHeight;
  }

  public java.lang.String getImage() {
    if (image != null) {
      return image;
    }
    ValueExpression ve = getValueExpression("image");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setImage(java.lang.String image) {
    this.image = image;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    if (display != null) {
      return display;
    }
    ValueExpression ve = getValueExpression("display");
    if (ve != null) {
      try {
        return (org.apache.myfaces.tobago.layout.Display) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    this.display = display;
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    if (maximumWidth != null) {
      return maximumWidth;
    }
    ValueExpression ve = getValueExpression("maximumWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this);
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    this.maximumWidth = maximumWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    if (preferredWidth != null) {
      return preferredWidth;
    }
    ValueExpression ve = getValueExpression("preferredWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this);
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    this.preferredWidth = preferredWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    if (marginBottom != null) {
      return marginBottom;
    }
    ValueExpression ve = getValueExpression("marginBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this);
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    this.marginBottom = marginBottom;
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    if (verticalIndex != null) {
      return verticalIndex;
    }
    ValueExpression ve = getValueExpression("verticalIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    this.verticalIndex = verticalIndex;
  }

  public String[] getRenderedPartially() {
    if (renderedPartially != null) {
      return renderedPartially;
    }
    ValueExpression ve = getValueExpression("renderedPartially");
    if (ve != null) {
      try {
        Object strArray = ve.getValue(getFacesContext().getELContext());
        if (strArray instanceof String[]) {
          return (String[]) strArray;
        } else if (strArray instanceof String) {
          String[] strings = StringUtils.split((String) strArray, ", ");
          List<String> result = new ArrayList<String>(strings.length);
          for (String string : strings) {
            if (string.trim().length() != 0) {
              result.add(string.trim());
            }
          }
          return result.toArray(new String[result.size()]);
        } else if (strArray == null) {
          return ArrayUtils.EMPTY_STRING_ARRAY;
        } else {
          return new String[]{strArray.toString()};
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ArrayUtils.EMPTY_STRING_ARRAY;
  }

  public void setRenderedPartially(String[] renderedPartially) {
    this.renderedPartially = renderedPartially;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  public java.lang.String getOnclick() {
    if (onclick != null) {
      return onclick;
    }
    ValueExpression ve = getValueExpression("onclick");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setOnclick(java.lang.String onclick) {
    this.onclick = onclick;
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    if (horizontalIndex != null) {
      return horizontalIndex;
    }
    ValueExpression ve = getValueExpression("horizontalIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    this.horizontalIndex = horizontalIndex;
  }

  public boolean isDisabled() {
    if (disabled != null) {
      return disabled;
    }
    ValueExpression ve = getValueExpression("disabled");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    markup = (org.apache.myfaces.tobago.context.Markup) values[1];
    marginLeft = (org.apache.myfaces.tobago.layout.Measure) values[2];
    forComponent = (java.lang.String) values[3];
    link = (java.lang.String) values[4];
    tabIndex = (java.lang.Integer) values[5];
    minimumHeight = (org.apache.myfaces.tobago.layout.Measure) values[6];
    tip = (java.lang.String) values[7];
    height = (org.apache.myfaces.tobago.layout.Measure) values[8];
    minimumWidth = (org.apache.myfaces.tobago.layout.Measure) values[9];
    rowSpan = (java.lang.Integer) values[10];
    left = (org.apache.myfaces.tobago.layout.Measure) values[11];
    columnSpan = (java.lang.Integer) values[12];
    maximumHeight = (org.apache.myfaces.tobago.layout.Measure) values[13];
    top = (org.apache.myfaces.tobago.layout.Measure) values[14];
    currentWidth = (org.apache.myfaces.tobago.layout.Measure) values[15];
    marginTop = (org.apache.myfaces.tobago.layout.Measure) values[16];
    marginRight = (org.apache.myfaces.tobago.layout.Measure) values[17];
    width = (org.apache.myfaces.tobago.layout.Measure) values[18];
    resource = (java.lang.String) values[19];
    jsfResource = (java.lang.Boolean) values[20];
    currentHeight = (org.apache.myfaces.tobago.layout.Measure) values[21];
    preferredHeight = (org.apache.myfaces.tobago.layout.Measure) values[22];
    image = (java.lang.String) values[23];
    display = (org.apache.myfaces.tobago.layout.Display) values[24];
    maximumWidth = (org.apache.myfaces.tobago.layout.Measure) values[25];
    preferredWidth = (org.apache.myfaces.tobago.layout.Measure) values[26];
    marginBottom = (org.apache.myfaces.tobago.layout.Measure) values[27];
    verticalIndex = (java.lang.Integer) values[28];
    renderedPartially = (java.lang.String[]) values[29];
    onclick = (java.lang.String) values[30];
    horizontalIndex = (java.lang.Integer) values[31];
    disabled = (java.lang.Boolean) values[32];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[33];
    values[0] = super.saveState(context);
    values[1] = markup;
    values[2] = marginLeft;
    values[3] = forComponent;
    values[4] = link;
    values[5] = tabIndex;
    values[6] = minimumHeight;
    values[7] = tip;
    values[8] = height;
    values[9] = minimumWidth;
    values[10] = rowSpan;
    values[11] = left;
    values[12] = columnSpan;
    values[13] = maximumHeight;
    values[14] = top;
    values[15] = currentWidth;
    values[16] = marginTop;
    values[17] = marginRight;
    values[18] = width;
    values[19] = resource;
    values[20] = jsfResource;
    values[21] = currentHeight;
    values[22] = preferredHeight;
    values[23] = image;
    values[24] = display;
    values[25] = maximumWidth;
    values[26] = preferredWidth;
    values[27] = marginBottom;
    values[28] = verticalIndex;
    values[29] = renderedPartially;
    values[30] = onclick;
    values[31] = horizontalIndex;
    values[32] = disabled;
    currentMarkup = null;
    return values;
  }


}